package dev.peerat.parser.java.operation;

import java.util.List;
import java.util.function.Function;

import dev.peerat.parser.Token;
import dev.peerat.parser.java.JavaElement;
import dev.peerat.parser.java.Operation;
import dev.peerat.parser.java.Value;

public class MethodCallOperation extends Operation{
	
	private Value start;
	private MethodCallOperation previous;
	private Token path;
	private List<Value> parameters;
	
	public MethodCallOperation(Value start, Token path, List<Value> parameters){
		this.start = start;
		this.path = path;
		this.parameters = parameters;
	}
	
	public MethodCallOperation(MethodCallOperation previous, Token path, List<Value> parameters){
		this((Value)null, path, parameters);
		this.previous = previous;
	}
	
	public MethodCallOperation getPrevious(){
		return this.previous;
	}
	
	public Token getPath(){
		return path;
	}
	
	public List<Value> getParameters(){
		return this.parameters;
	}
	
	@Override
	public void build(Builder builder) throws Exception{
		if(previous != null) previous.build(builder);
		//todo
	}

	@Override
	public <E extends JavaElement> E find(Function<JavaElement, Boolean> finder) {
		if(finder.apply(start)) return (E)start;
		if(previous != null) if(finder.apply(previous)) return (E) previous;
		for(Value param : this.parameters){
			if(finder.apply(param)) return (E)param;
		}
		return null;
	}

}
